package nl.tue.declare.appl.framework.recommendation;


import org.processmining.models.operationalsupport.Request;
import org.processmining.models.operationalsupport.Response;
import org.processmining.models.operationalsupport.net.client.OperationalSupportClient;

import nl.tue.declare.utils.sockets.*;

public class RecommendationProxy
   /* implements RecommendationProvider*/ {

  private OperationalSupportClient provider; // ProM recommendation provider proxy

  public RecommendationProxy(String host, int port) {
    super();
    if (host == null) {
      host = SocketConnection.LOCAL_HOST;
    }
    provider = new OperationalSupportClient(host, port);
  }

  /**
   * Ask for the recommendation.
   * @param request RecommendationQuery Query for the specific recommendation.
   * @return RecommendationResult Result received from the external recomendatiom system.
   * @throws Exception
   * @throws IOException
   */
  public Response getRecommendation(Request request) {
    Response response = null;
    try {
      response = provider.getResponse(request);
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
    return response;
  }
}
