package nl.tue.declare.appl.worklist.gui;

import java.awt.*;
import javax.swing.*;

import org.processmining.models.operationalsupport.Response;
import org.processmining.models.operationalsupport.gui.ResponseVisualizer;

import nl.tue.declare.appl.util.swing.*;

public class RecommendationPanel extends TPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -4936361359815382915L;
	private static final String PREFIX = "Value of current trace: ";
	private JLabel currentValueLabel = new JLabel(PREFIX);
	
	private ResponseVisualizer responseVisualizer;
	private JPanel main = new JPanel(new BorderLayout());
	
	private boolean empty = true;

	public RecommendationPanel() {
		super(new BorderLayout(), "recommendation");
		empty = true;
		this.responseVisualizer = new ResponseVisualizer();
		add(new JLabel("Recommendations are curently not available!"), BorderLayout.CENTER);
	}
	
	private void setUp(){
		if (empty){
			removeAll();			
			add(new JScrollPane(main),BorderLayout.CENTER);
			JPanel panel = new JPanel(new BorderLayout());
			panel.add(currentValueLabel, BorderLayout.CENTER);
			add(panel, BorderLayout.SOUTH);
			empty = false;
		}
	}

	/**
	 * 
	 * @param result
	 *            RecommendationResult
	 */
	public void setRecommendationResult(Response result) {
		setUp();
		//double val = result.getPartialTraceValue();
		if (result != null) {
			main.removeAll();
			main.add(responseVisualizer.getVisualizationPanel(result),BorderLayout.CENTER);
		}
		//currentValueLabel.setText(PREFIX + val);
		revalidate();
	}

	/**
   *
   */
	public void clear() {
		main.removeAll();
	}

}
